JAGUARETE_KAA/CARRO/urls.py
from django.urls import path
from .views import *

app_name = "carro"

urlpatterns = [
    path("carro/", listado_carro, name='carro'),
    path("agregar/<int:producto_id>/", agregar_producto, name="agregar"),
    path("eliminar/<int:producto_id>/", eliminar_producto, name="eliminar"),
    path("restar/<int:producto_id>/", restar_producto, name="restar"),
    path("vaciar/", vaciar_carro, name="vaciar"),

]

JAGUARETE_KAA/JAGUARETE_KAA/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include("USUARIOS.urls")),
    path('', include("JUGUETES.urls")),
    path('', include("CARRO.urls")),
    
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

JAGUARETE_KAA/JUGUETES/urls.py
from django.urls import path
from .views import *

urlpatterns = [
    path('', index, name="juguetes"),
    path('agregar/producto/', agregar_producto, name="agregar_producto"),
    path('eliminar/producto/<int:producto_id>', eliminar_producto, name="eliminar_producto"),
    path('editar/producto/<int:producto_id>', editar_producto, name="editar_producto"),
    path('acerca_de/', acercade, name="acercade"),
]   

JAGUARETE_KAA/JUGUETES/models.py
import os
from django.db import models
from django.contrib.auth.models import User
from django.utils import tree

# Create your models here.
class Categoria(models.Model):
    nombre = models.CharField(max_length=100, null=False, unique=True, verbose_name='Nombre')
    
    def __str__(self):
        return self.nombre
        
    class Meta:
        db_table = 'categories'
        verbose_name = 'Categoría'
        verbose_name_plural = 'Categorías'
        ordering = ['id']


class Producto(models.Model):
    nombre = models.CharField(max_length=300, verbose_name='Nombre')
    categoria = models.ForeignKey(Categoria, on_delete=models.CASCADE, verbose_name='Categoría')
    imagen = models.ImageField(upload_to='productos/', blank=False, verbose_name='Imagen')
    descripcion = models.TextField(max_length=1000, verbose_name='Descripción')
    precio = models.FloatField(verbose_name='Precio')

    def delete(self, *args, **kwargs):
        if os.path.isfile(self.imagen.path):
            os.remove(self.imagen.path)
        super(Producto, self).delete(*args, **kwargs)

    def __str__(self):
        return self.nombre

    class Meta:
        db_table = 'products'
        verbose_name = 'Producto'
        verbose_name_plural = 'Productos'
        ordering = ['id']

JAGUARETE_KAA/JUGUETES/forms.py
from django import forms
from django.http.response import HttpResponseRedirect
#from django.conf import settings
#from django.conf.urls.static import static
#from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.shortcuts import render
from .models import Producto, Categoria


class FormularioCategorias(forms.ModelForm):
    class Meta:
        model = Categoria
        fields = ('nombre',)


class FormularioProductos(forms.ModelForm):
    class Meta:
        model = Producto
        fields = ('nombre', 'categoria', 'imagen', 'descripcion', 'precio')

JAGUARETE_KAA/JUGUETES/views.py
#from django.http import HttpResponseRedirect
from django.db.models import Q
from typing import Text
from django.db.models.fields import TextField
from django.http import request
from django.shortcuts import render, redirect
from django.contrib import messages
from JUGUETES.models import Producto, Categoria
from django.core.paginator import Paginator
from django.contrib.auth.decorators import login_required
from django.contrib.admin.views.decorators import staff_member_required

#from django.urls import reverse
from .forms import FormularioProductos



def index(request):
    categorias = Categoria.objects.all()
    lista_productos = Producto.objects.all().reverse()
    queryset = request.GET.get("busqueda")
    if queryset:
        lista_productos = Producto.objects.filter(
            Q(nombre__icontains=queryset) |
            Q(descripcion__icontains=queryset)
        ).distinct()
    paginador = Paginator(lista_productos, 10)
    pagina = request.GET.get("page") or 1
    products = paginador.get_page(pagina)
    pagina_actual = int(pagina)
    paginas = range(1, products.paginator.num_pages + 1)
    contexto = {"productos": products,
                "paginas": paginas,
                "pagina_actual": pagina_actual,
                "categorias": categorias}
    return render(request, "juguetes.html", contexto)
    

#agregar producto
@login_required(login_url='/accounts/acceder')
def agregar_producto(request):
    categorias = Categoria.objects.all()
    if request.method == "POST":
        form = FormularioProductos(request.POST, request.FILES)
        if form.is_valid():
            form.save()
            titulo = form.cleaned_data.get("nombre")
            messages.success(request, f"El producto {titulo} se ha agregado correctamente")
        else:
            for msg in form.error_messages:
                messages.error(request, form.error_messages[msg])
        
    form = FormularioProductos()
    return render(request, "agregar_producto.html", {
        "form": form,
        "categorias": categorias
    })


@login_required(login_url='/accounts/acceder')
def eliminar_producto(request, producto_id):
    try:
        producto = Producto.objects.get(pk=producto_id)
    except Producto.DoesNotExist:
        messages.error(request, "El producto que intentas eliminar no existe")
        return redirect("juguetes")
    
    producto.delete()
    messages.success(request, f"El producto {producto.nombre} ha sido eliminado!")
    return redirect("juguetes")
    


@staff_member_required(login_url='/accounts/acceder')
def editar_producto(request, producto_id):
    categories = Categoria.objects.all()
    list_products = Producto.objects.all()
    producto = Producto.objects.get(id=producto_id)
    if request.method == 'GET':
        form = FormularioProductos(instance=producto)
        contexto = {'form': form, "productos": list_products, "categorias": categories}
    else:
        form = FormularioProductos(request.POST, instance=producto)
        if form.is_valid():
            form.save()
            return redirect("juguetes")

    return render(request, 'agregar_producto.html', contexto)

def acercade(request):
    categories = Categoria.objects.all()
    list_products = Producto.objects.all()
    contexto = {"productos": list_products, "categorias": categories}
    return render(request, "acerca_de.html", contexto)

JAGUARETE_KAA/JUGUETES/templates/acerca_de.html
{% extends 'layout.html' %}

{% block title %}Acerca de nosotros{%endblock %}

{% block content %}

    <div class="jumbotron backg">
        <h1 class="display-4">Acerca de nosotros</h1>
        <p class="lead">Lorem ipsum dolor sit amet, consectetur adipisicing elit. At beatae blanditiis, culpa dolorem doloremque fugiat, hic illum impedit laudantium odio perspiciatis quia quidem quisquam repellat reprehenderit sunt tempora temporibus vero?</p>
        <hr class="my-4">
        <p>Lorem ipsum dolor sit, amet consectetur adipisicing elit. Distinctio, cumque doloribus laudantium fugit rerum libero id! Autem, blanditiis ex eos, rem deserunt perferendis dicta, libero earum aliquam officiis sequi incidunt!.  Lorem ipsum dolor sit amet, consectetur adipisicing elit. Alias asperiores deleniti dolorem eius, expedita explicabo facere fuga fugit in iure mollitia nihil nisi ratione sed suscipit ut voluptate. Amet, est?</p>
    </div>

{% endblock %}

JAGUARETE_KAA/JUGUETES/templates/agregar_producto.html
{% extends 'layout.html' %}

{% block title %}Agregar Producto{% endblock %}

{% load crispy_forms_tags %}

{% block content %}
    <form method="POST" action="" class="mt-3" autocomplete="off" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form|crispy }}
        <button type="submit" class="btn btn-success">Guardar</button>
    </form>
{% endblock %}

JAGUARETE_KAA/JUGUETES/templates/juguetes.html
{% extends 'layout.html' %}

{% block title %}Juguetes{% endblock %}

{% block content %}
    <div class="mt-3">    
            {% if productos %}
                {% for producto in productos|slice:":3" %}
                    {% if forloop.first %}
                    <div class="row">
                    {% endif %}
                        <div class="col-4">
                            <div class="card">
                                <img class="card-img-top" height="180" src="{{ producto.imagen.url }}" alt="{{ producto.imagen }}">
                                <div class="card-body">
                                    <h5 class="card-title">{{ producto.nombre }}</h5>
                                    <p class="card-text">Ver.</p>
                                    <hr/>
                                    <h6 class="card-subtitle">Nombre: {{ producto.nombre }}</h6>
                                    <p class="card-text">Categoria: {{ producto.categoria }}</p>
                                </div>
                                <div class="card-footer">
                                    {% if request.user.is_staff %}
                                        <a href ="{% url 'eliminar_producto' producto.id %}" class="btn btn-danger">Eliminar producto</a>
                                        <a href ="{% url 'editar_producto' producto.id %}" class="btn btn-warning">Editar producto</a>
                                    {% else %}
                                        <a href ="{% url 'carro:agregar' producto.id %}" class="btn btn-lg btn-success ">Agregar a carrito</a>
                                    {% endif %} 
                                </div>
                            </div>
                        </div>
                    {% if forloop.counter|divisibleby:3 %}
                    </div>
                    <div class="row">
                    {% endif %}
                    {% if forloop.last %}
                    </div>
                    {% endif %}                
                {% endfor %} 
                
                
                <div class="my-2 px-3 pt-2 rounded backg">
                    <h3 class="">Más productos</h3>
                    <ul class="list-group list-group-flush rounded">
                        {% for producto in productos|slice:":10" %}
                            {% if forloop.counter > 3 %}
                                <li class="list-group-item backg d-flex justify-content-between align-items-center">
                                    <div>
                                        <h5>{{producto.nombre}}</h5>
                                    </div>
                                    <div>
                                    <strong>${{producto.precio}}</strong>
                                    {% if request.user.is_staff %}
                                    <a href ="{% url 'eliminar_producto' producto.id %}" class="btn btn-danger">Eliminar producto</a>
                                    <a href ="{% url 'editar_producto' producto.id %}" class="btn btn-warning">Editar producto</a>
                                    {% else %}
                                        <a href="{% url 'carro:agregar' producto.id %}" class="btn btn-success px-1">Agregar al carrito</a>
                                    {% endif %}
                                    </div>
                                </li>
                            {% endif %}
                        {% endfor %}
                    </ul>
                </div>
            {% endif %}
            
            {% include "paginacion.html" %}     
            
{% endblock %}

JAGUARETE_KAA/JUGUETES/templates/layout.html
<!DOCTYPE html>
<html lang="es">
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
		<meta http-equiv="X-UA-Compatible" content="ie=edge">
		
		{% load static %}

			<link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}"/>
            <link rel="stylesheet" type="text/css" href="{% static 'css/style.css' %}"/>
			<link rel="stylesheet" type="text/css" href="{% static 'css/estilos.css' %}"/>
			<title>{% block title %}{% endblock %} - JAGUARETE_KAA</title>
	</head>

	<body>
	
		<header>
			<nav class="navbar navbar-dark bg-dark">
				<a class="navbar-brand" href="{% url 'juguetes' %}">
				  <img src="{% static 'images/logo.jpg' %}" alt="140" width="140" height="140" class="d-inline-block align-text-top">
				</a>
				<a class="navbar-brand" href="HOME">
				<form method="POST" action="/" class="mt-2" autocomplete="off" alt="140" width="140" height="140">
					<ul class="navbar-nav ml-auto">
						{% if user.is_authenticated %}
							<li class="nav-item">
								<a class="nav-link" href="#">Hola {{ user.username }}</a>
							</li>
							<li class="nav-item">
								<a class="nav-link" href="{% url 'salir' %}">Cerrar Sesión</a>
							</li>
							
						{% else %}	
							<li class="nav-item">
								<a class="nav-link" href="{% url 'acceder' %}">Acceder</a>
							</li>
							<li class="nav-item">
								<a class="nav-link" href="{% url 'registro' %}">Registro</a>
							</li>
						{% endif %}
						{% if not user.is_staff %}
						<li class="nav-item">
							<a class="nav-link" href="{% url 'carro:carro' %}">
								<h5>Carrito</h5>
							</a>
						</li>
						{% endif %}
							
					</ul>
				</form>
			</nav>
<!-- 2do NAV DE MENU -->
            <nav class="navbar navbar-expand-lg navbar-light">
                <a class="navbar-brand"></a>
                <button class="btn btn-light navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icono"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav mr-auto font-weight-bolder">
                        <li class="nav-item active">
                            <a class="nav-link" href="{% url 'juguetes' %}">HOME <span class="sr-only">(current)</span></a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                CATEGORIAS
                            </a>
                            <div class="dropdown-menu" aria-labelledby="navbarDropdown">

                                {% for categoria in categorias %}
                                <a class="dropdown-item" href="#">{{categoria.nombre}}</a>
                                {% endfor %}

                            </div>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="{% url 'acercade' %}" tabindex="-1" aria-disabled="true">ACERCA DE</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="mailto:torresetania@gmail.com" tabindex="-1" aria-disabled="true">CONTACTO</a>
                        </li>
                        {% if request.user.is_staff %}
                        <li class="nav-item">
                            <a class="nav-link" href="{% url 'agregar_producto' %}" tabindex="-1" aria-disabled="true">NUEVO PRODUCTO</a>
                        </li>
                        {% endif %}
                    </ul>
<!-- Buscador -->
                    <form class="form-inline my-2 my-lg-0" method="get">
                       <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search" name="busqueda">
                       <button class="btn btn-info my-2 my-sm-0" type="submit">Search</button>
                    </form>

                </div>
            </nav>	
		</header>
		
		<main class="container">
		


		
		
			{% if messages %}
				<div class="row mt-3 mb-3">
					<div class="col-12">
				        {% for message in messages %}
							<div class="alert alert-{{ message.tags }}">
						        {{ message }}
							</div>
						{% endfor %}
					</div>
			    </div>
			{% endif %}
			
			
		
			{% block content %}
			

			
			{% endblock %}
			
			
	    </main>
	    
		<footer class="mt-3">
			<div class="card-footer bg-dark">
				<small class="text-muted">Todos los derechos reservados. © Torrese INC 2021.</small>
				<small class="text-muted">Desarrollador: Tania Elizabeth Torres</small>
			</div>
		</footer>
	  

		<script src="{% static 'js/jquery.slim.min.js' %}"></script>
		<script src="{% static 'js/popper.min.js' %}"></script>
		<script src="{% static 'js/bootstrap.min.js' %}"></script>
	</body>

</html>

JAGUARETE_KAA/JUGUETES/templates/paginacion.html
<div class="row mt-3 justify-content-center">
    <nav>
        <ul class="pagination">
            {% if productos.has_previous %}
                <li class="page-item">
                    <a class="page-link" href="?page=1">Primera</a>
                </li>
                <li class="page-item">
                    <a class="page-link" href="?page={{ productos.previous_page_number }}">&laquo;</a>
                </li>
            {% endif %}
            
            {% for pagina in paginas %}
                <li class="page-item{% if pagina_actual == pagina %} active{% endif %}">
                    <a class="page-link" href="?page={{ pagina }}">{{ pagina }}</a>
                </li>
            {% endfor %}
            
            {% if productos.has_next %}
                <li class="page-item">
                    <a class="page-link" href="?page={{ productos.next_page_number }}">&raquo;</a>
                </li>
                <li class="page-item">
                    <a class="page-link" href="?page={{ productos.paginator.num_pages }}">Última</a>
                </li>
            {% endif %}
        </ul>
    </nav>
</div>